# -*- Mode: python; coding: utf-8; tab-width: 4; indent-tabs-mode: nil; -*-
#
#   TestPlugin.py
#
#   A test plugin for Rhythmbox.
#   Copyright (C) 2013 Donagh Horgan <donagh.horgan@gmail.com>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

from gi.repository import GObject
from gi.repository import Peas
from gi.repository import RB
from gi.repository import Gtk
from gi.repository import Gio

location = 'playlist-toolbar'

class TestPlugin (GObject.Object, Peas.Activatable):
    object = GObject.property (type = GObject.Object)

    def __init__(self):
        GObject.Object.__init__(self)

    def log(self, function_name, message, error=False):
        if error:
            message_type = 'ERROR'
        else:
            message_type = 'DEBUG'
        print(function_name + ': ' + message_type + ': ' + message)

    def do_activate(self):
        self.log(self.do_activate.__name__, 'Activating plugin...')
        
        app = Gio.Application.get_default()
        
        action = Gio.SimpleAction(name='test')
        action.connect('activate', self.test_callback)
        app.add_action(action)

        item = Gio.MenuItem()
        item.set_label('Test')
        item.set_detailed_action('app.test')
        
        app.add_plugin_menu_item(location, 'test-plugin', item)
    
    def test_callback(self, action, parameter):
        self.log(self.test_callback.__name__, 'Hello, world!')

    def do_deactivate(self):
        self.log(self.do_deactivate.__name__, 'Deactivating plugin...')

        app = Gio.Application.get_default()
        app.remove_plugin_menu_item(location, 'test-plugin')


